class bi_elasticsearch::server (
    $service_name = hiera("service_name", undef),
    $enable = hiera("enable", true),
    $ensure = hiera("ensure", 'running'),
) {

    if $service_name == undef or !is_string($service_name) { 
        fail("'package_name' must be defined") 
    }
    
    if $enable == undef or !is_bool($enable) { 
        fail("'enable' must be defined") 
    }
    
    if $ensure == undef or !is_string($ensure) { 
        fail("'ensure' must be defined") 
    }
    
    include ::bi_elasticsearch
    include ::bi_elasticsearch::server::install
    include ::bi_elasticsearch::server::service
    include ::bi_elasticsearch::conf::elasticsearch
    include ::bi_elasticsearch::conf::logging
    
    anchor { 'bi_elasticsearch::server::start': }
    anchor { 'bi_elasticsearch::server::end': }
    
    Class[::bi_elasticsearch::conf::elasticsearch] ~> Class[::bi_elasticsearch::server::service]
    Class[::bi_elasticsearch::conf::logging] ~> Class[::bi_elasticsearch::server::service]
    
    Anchor['bi_elasticsearch::server::start'] ->
    Class[::bi_elasticsearch] ->
    Class[::bi_elasticsearch::server::install] ->
    Class[::bi_elasticsearch::conf::elasticsearch] ->
    Class[::bi_elasticsearch::conf::logging] ->
    Class[::bi_elasticsearch::server::service] ->
    Anchor['bi_elasticsearch::server::end']
}
