class bi_elasticsearch::server::install {

    if $bi_elasticsearch::rpm_url == undef or !is_string($bi_elasticsearch::rpm_url) { 
        fail("'bi_elasticsearch::rpm_url' must be defined") 
    }
    
    if $bi_elasticsearch::package_name == undef or !is_string($bi_elasticsearch::package_name) { 
        fail("'bi_elasticsearch::package_name' must be defined") 
    }
    
    $filename = basename($::bi_elasticsearch::rpm_url)
    $localfile = "$::bi_elasticsearch::tmp_dir/$filename"
    
    bi_wget::wget { $bi_elasticsearch::rpm_url:
        output_document => $localfile,
        no_clobber => true,
    }
    
    package { $bi_elasticsearch::package_name:
        ensure => 'installed',
        provider => rpm,
        source => $localfile,
        require => Bi_wget::Wget[$bi_elasticsearch::rpm_url],
        #allow_virtual => false, # don't work in puppet 3.4.3
    }
    
    # Explicitly set allow_virtual to disable deprecation warning
    # http://docs.puppetlabs.com/puppet/3.6/reference/release_notes.html#changes-to-rpm-behavior-with-virtual-packages
  
}
